Index: uspace/app/edit/search.c
===================================================================
--- uspace/app/edit/search.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/app/edit/search.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -35,7 +35,8 @@
  */
 
+#include <errno.h>
 #include <stdlib.h>
 #include <stddef.h>
-#include <errno.h>
+#include <types/common.h>
 
 #include "search.h"
Index: uspace/app/tester/float/softfloat1.c
===================================================================
--- uspace/app/tester/float/softfloat1.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/app/tester/float/softfloat1.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -31,4 +31,5 @@
 #include <stdbool.h>
 #include <stddef.h>
+#include <inttypes.h>
 #include <mathtypes.h>
 #include <add.h>
Index: uspace/app/tester/print/print4.c
===================================================================
--- uspace/app/tester/print/print4.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/app/tester/print/print4.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -29,4 +29,5 @@
 #include <stdio.h>
 #include <stddef.h>
+#include <wchar.h>
 #include "../tester.h"
 
Index: uspace/app/tester/util.h
===================================================================
--- uspace/app/tester/util.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/app/tester/util.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -37,4 +37,5 @@
 
 #include <stdio.h>
+#include <inttypes.h>
 #include "tester.h"
 
Index: uspace/lib/bithenge/src/print.c
===================================================================
--- uspace/lib/bithenge/src/print.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/bithenge/src/print.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -40,4 +40,5 @@
 #include <stdarg.h>
 #include <stdio.h>
+#include <wchar.h>
 #include <bithenge/blob.h>
 #include <bithenge/print.h>
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/Makefile	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -32,5 +32,4 @@
 
 CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
-COMMON_HEADER_ARCH = arch/$(UARCH)/include/libarch/common.h
 
 LINKER_SCRIPTS = \
@@ -40,7 +39,7 @@
 	$(LIBC_PREFIX)/arch/$(UARCH)/_link-dlexe.ld
 
-PRE_DEPEND = $(COMMON_HEADER_ARCH)
+PRE_DEPEND =
 EXTRA_OUTPUT = $(LINKER_SCRIPTS)
-EXTRA_CLEAN = $(COMMON_HEADER_ARCH) $(LINKER_SCRIPTS)
+EXTRA_CLEAN = $(LINKER_SCRIPTS)
 LIBRARY = libc
 SLIBRARY = libc.so.0.0
@@ -208,5 +207,2 @@
 $(LIBC_PREFIX)/arch/$(UARCH)/_link-dlexe.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
 	$(CC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -DDLEXE -E -x c $< | grep -v "^\#" > $@
-
-$(COMMON_HEADER_ARCH): $(COMMON_HEADER)
-	ln -sfn ../../../../$< $@
Index: uspace/lib/c/arch/ia64/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/faddr.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/arch/ia64/include/libarch/faddr.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,4 +38,9 @@
 #include <types/common.h>
 
+typedef struct {
+	uintptr_t fnc;
+	uintptr_t gp;
+} __attribute__((may_alias)) fncptr_t;
+
 /**
  *
Index: uspace/lib/c/generic/double_to_str.c
===================================================================
--- uspace/lib/c/generic/double_to_str.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/generic/double_to_str.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -32,4 +32,5 @@
 #include <ieee_double.h>
 
+#include <limits.h>
 #include <stdint.h>
 #include <stdbool.h>
Index: uspace/lib/c/generic/gsort.c
===================================================================
--- uspace/lib/c/generic/gsort.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/generic/gsort.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -41,4 +41,5 @@
 
 #include <gsort.h>
+#include <inttypes.h>
 #include <mem.h>
 #include <malloc.h>
Index: uspace/lib/c/generic/inet/addr.c
===================================================================
--- uspace/lib/c/generic/inet/addr.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/generic/inet/addr.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -41,4 +41,5 @@
 #include <malloc.h>
 #include <bitops.h>
+#include <inttypes.h>
 
 #define INET_PREFIXSTRSIZE  5
Index: uspace/lib/c/generic/io/printf_core.c
===================================================================
--- uspace/lib/c/generic/io/printf_core.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/generic/io/printf_core.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -46,4 +46,5 @@
 #include <assert.h>
 #include <macros.h>
+#include <wchar.h>
 
 
@@ -114,5 +115,6 @@
 	PrintfQualifierLongLong,
 	PrintfQualifierPointer,
-	PrintfQualifierSize
+	PrintfQualifierSize,
+	PrintfQualifierMax
 } qualifier_t;
 
@@ -1484,4 +1486,9 @@
 				uc = str_decode(fmt, &nxt, STR_NO_LIMIT);
 				break;
+			case 'j':
+				qualifier = PrintfQualifierMax;
+				i = nxt;
+				uc = str_decode(fmt, &nxt, STR_NO_LIMIT);
+				break;
 			default:
 				/* Default type */
@@ -1629,4 +1636,8 @@
 				number = (uint64_t) va_arg(ap, size_t);
 				break;
+			case PrintfQualifierMax:
+				size = sizeof(uintmax_t);
+				number = (uint64_t) va_arg(ap, uintmax_t);
+				break;
 			default:
 				/* Unknown qualifier */
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/generic/str.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -46,7 +46,8 @@
 #include <align.h>
 #include <mem.h>
+#include <limits.h>
 
 /** Check the condition if wchar_t is signed */
-#ifdef WCHAR_IS_UNSIGNED
+#ifdef __WCHAR_UNSIGNED__
 	#define WCHAR_SIGNED_CHECK(cond)  (true)
 #else
Index: uspace/lib/c/include/inttypes.h
===================================================================
--- uspace/lib/c/include/inttypes.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/include/inttypes.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,5 +36,5 @@
 #define LIBC_INTTYPES_H_
 
-#include <libarch/inttypes.h>
+#include <_bits/inttypes.h>
 
 #endif
Index: uspace/lib/c/include/io/charfield.h
===================================================================
--- uspace/lib/c/include/io/charfield.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/include/io/charfield.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,4 +38,5 @@
 
 #include <stdbool.h>
+#include <wchar.h>
 #include <io/color.h>
 #include <io/style.h>
Index: uspace/lib/c/include/limits.h
===================================================================
--- uspace/lib/c/include/limits.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/include/limits.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,7 +36,5 @@
 #define LIBC_LIMITS_H_
 
-/* XXX Make this more accurate */
-#include <stdint.h>
-#include <libarch/stdint.h>
+#include <_bits/limits.h>
 
 #endif
Index: uspace/lib/c/include/stddef.h
===================================================================
--- uspace/lib/c/include/stddef.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/include/stddef.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,9 +36,9 @@
 #define LIBC_STDDEF_H_
 
-#include <libarch/stddef.h>
+#include <_bits/size_t.h>
+#include <_bits/ptrdiff_t.h>
+#include <_bits/wchar_t.h>
 
-#ifndef NULL
-	#define NULL  ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 #define offsetof(type, member) \
Index: uspace/lib/c/include/stdint.h
===================================================================
--- uspace/lib/c/include/stdint.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/include/stdint.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,29 +36,5 @@
 #define LIBC_STDINT_H_
 
-#define INT8_MIN  INT8_C(0x80)
-#define INT8_MAX  INT8_C(0x7F)
-
-#define UINT8_MIN  UINT8_C(0)
-#define UINT8_MAX  UINT8_C(0xFF)
-
-#define INT16_MIN  INT16_C(0x8000)
-#define INT16_MAX  INT16_C(0x7FFF)
-
-#define UINT16_MIN  UINT16_C(0)
-#define UINT16_MAX  UINT16_C(0xFFFF)
-
-#define INT32_MIN  INT32_C(0x80000000)
-#define INT32_MAX  INT32_C(0x7FFFFFFF)
-
-#define UINT32_MIN  UINT32_C(0)
-#define UINT32_MAX  UINT32_C(0xFFFFFFFF)
-
-#define INT64_MIN  INT64_C(0x8000000000000000)
-#define INT64_MAX  INT64_C(0x7FFFFFFFFFFFFFFF)
-
-#define UINT64_MIN  UINT64_C(0)
-#define UINT64_MAX  UINT64_C(0xFFFFFFFFFFFFFFFF)
-
-#include <libarch/stdint.h>
+#include <_bits/stdint.h>
 
 #endif
Index: uspace/lib/c/include/types/common.h
===================================================================
--- uspace/lib/c/include/types/common.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/c/include/types/common.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,5 +36,13 @@
 #define LIBC_TYPES_COMMON_H_
 
-#include <libarch/types.h>
+#if __SIZEOF_POINTER__ == 4
+#define __32_BITS__
+#elif __SIZEOF_POINTER__ == 8
+#define __64_BITS__
+#else
+#error __SIZEOF_POINTER__ is not defined.
+#endif
+
+#include <_bits/all.h>
 
 #endif
Index: uspace/lib/c/include/wchar.h
===================================================================
--- uspace/lib/c/include/wchar.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
+++ uspace/lib/c/include/wchar.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2017 CZ.NIC, z.s.p.o.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/* Authors:
+ *	Jiří Zárevúcky (jzr) <zarevucky.jiri@gmail.com>
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_WCHAR_H_
+#define LIBC_WCHAR_H_
+
+#include <_bits/size_t.h>
+#include <_bits/wchar_t.h>
+#include <_bits/wint_t.h>
+
+#include <_bits/NULL.h>
+#include <_bits/WCHAR_MIN.h>
+#include <_bits/WCHAR_MAX.h>
+#include <_bits/WEOF.h>
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/font-8x16.h
===================================================================
--- uspace/lib/draw/gfx/font-8x16.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/draw/gfx/font-8x16.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,4 +38,5 @@
 #include <stdint.h>
 #include <stdbool.h>
+#include <stddef.h>
 
 #define FONT_GLYPHS     2899
Index: uspace/lib/drv/Makefile
===================================================================
--- uspace/lib/drv/Makefile	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/Makefile	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -32,5 +32,4 @@
 	-Iinclude \
 	-Igeneric/private \
-	-I$(LIBUSB_PREFIX)/include \
 	-I$(LIBPCM_PREFIX)/include
 LIBRARY = libdrv
Index: uspace/lib/drv/generic/logbuf.c
===================================================================
--- uspace/lib/drv/generic/logbuf.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/generic/logbuf.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -31,5 +31,4 @@
  */
 
-#include <libarch/common.h>
 #include <stdio.h>
 #include <stddef.h>
Index: uspace/lib/drv/generic/remote_usb.c
===================================================================
--- uspace/lib/drv/generic/remote_usb.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/generic/remote_usb.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -35,4 +35,5 @@
 
 #include <async.h>
+#include <assert.h>
 #include <macros.h>
 #include <errno.h>
@@ -169,5 +170,6 @@
 }
 
-int static_assert[sizeof(sysarg_t) >= 4 ? 1 : -1];
+static_assert(sizeof(sysarg_t) >= 4);
+
 typedef union {
 	uint8_t arr[sizeof(sysarg_t)];
Index: uspace/lib/drv/include/ddf/interrupt.h
===================================================================
--- uspace/lib/drv/include/ddf/interrupt.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/include/ddf/interrupt.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,5 +36,4 @@
 #define DDF_INTERRUPT_H_
 
-#include <libarch/common.h>
 #include <types/common.h>
 #include <abi/ddi/irq.h>
Index: uspace/lib/drv/include/usb_iface.h
===================================================================
--- uspace/lib/drv/include/usb_iface.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/include/usb_iface.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -40,7 +40,54 @@
 #include "ddf/driver.h"
 #include <async.h>
-#include <usb/usb.h>
 
 typedef async_sess_t usb_dev_session_t;
+
+/** USB speeds. */
+typedef enum {
+	/** USB 1.1 low speed (1.5Mbits/s). */
+	USB_SPEED_LOW,
+	/** USB 1.1 full speed (12Mbits/s). */
+	USB_SPEED_FULL,
+	/** USB 2.0 high speed (480Mbits/s). */
+	USB_SPEED_HIGH,
+	/** Psuedo-speed serving as a boundary. */
+	USB_SPEED_MAX
+} usb_speed_t;
+
+/** USB endpoint number type.
+ * Negative values could be used to indicate error.
+ */
+typedef int16_t usb_endpoint_t;
+
+/** USB address type.
+ * Negative values could be used to indicate error.
+ */
+typedef int16_t usb_address_t;
+
+/** USB transfer type. */
+typedef enum {
+	USB_TRANSFER_CONTROL = 0,
+	USB_TRANSFER_ISOCHRONOUS = 1,
+	USB_TRANSFER_BULK = 2,
+	USB_TRANSFER_INTERRUPT = 3
+} usb_transfer_type_t;
+
+/** USB data transfer direction. */
+typedef enum {
+	USB_DIRECTION_IN,
+	USB_DIRECTION_OUT,
+	USB_DIRECTION_BOTH
+} usb_direction_t;
+
+/** USB complete address type.
+ * Pair address + endpoint is identification of transaction recipient.
+ */
+typedef union {
+	struct {
+		usb_address_t address;
+		usb_endpoint_t endpoint;
+	} __attribute__((packed));
+	uint32_t packed;
+} usb_target_t;
 
 extern usb_dev_session_t *usb_dev_connect(devman_handle_t);
Index: uspace/lib/drv/include/usbhc_iface.h
===================================================================
--- uspace/lib/drv/include/usbhc_iface.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/include/usbhc_iface.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -41,5 +41,5 @@
 
 #include "ddf/driver.h"
-#include <usb/usb.h>
+#include <usb_iface.h>
 #include <stdbool.h>
 
Index: uspace/lib/drv/include/usbhid_iface.h
===================================================================
--- uspace/lib/drv/include/usbhid_iface.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/drv/include/usbhid_iface.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,5 +38,4 @@
 
 #include "ddf/driver.h"
-#include <usb/usb.h>
 
 extern int usbhid_dev_get_event_length(async_sess_t *, size_t *);
Index: uspace/lib/http/include/http/receive-buffer.h
===================================================================
--- uspace/lib/http/include/http/receive-buffer.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/http/include/http/receive-buffer.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -39,4 +39,5 @@
 #include <adt/list.h>
 #include <stddef.h>
+#include <types/common.h>
 
 /** Receive data.
Index: uspace/lib/math/include/mathtypes.h
===================================================================
--- uspace/lib/math/include/mathtypes.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/math/include/mathtypes.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -191,85 +191,35 @@
 #endif
 
-
-#if defined(FLOAT_SIZE_32)
-
-#ifndef float32_t
-	#define float32_t  float
-#endif
-
-#elif defined(FLOAT_SIZE_64)
-
-#ifndef float64_t
-	#define float64_t  float
-#endif
-
-#elif defined(FLOAT_SIZE_96)
-
-#ifndef float96_t
-	#define float96_t  float
-#endif
-
-#elif defined(FLOAT_SIZE_128)
-
-#ifndef float128_t
-	#define float128_t  float
-#endif
-
-#endif
-
-
-#if defined(DOUBLE_SIZE_32)
-
-#ifndef float32_t
-	#define float32_t  double
-#endif
-
-#elif defined(DOUBLE_SIZE_64)
-
-#ifndef float64_t
-	#define float64_t  double
-#endif
-
-#elif defined(DOUBLE_SIZE_96)
-
-#ifndef float96_t
-	#define float96_t  double
-#endif
-
-#elif defined(DOUBLE_SIZE_128)
-
-#ifndef float128_t
-	#define float128_t  double
-#endif
-
-#endif
-
-
-#if defined(LONG_DOUBLE_SIZE_32)
-
-#ifndef float32_t
-	#define float32_t  long double
-#endif
-
-#elif defined(LONG_DOUBLE_SIZE_64)
-
-#ifndef float64_t
-	#define float64_t  long double
-#endif
-
-#elif defined(LONG_DOUBLE_SIZE_96)
-
-#ifndef float96_t
-	#define float96_t  long double
-#endif
-
-#elif defined(LONG_DOUBLE_SIZE_128)
-
-#ifndef float128_t
-	#define float128_t  long double
-#endif
-
-#endif
-
+#if __SIZEOF_FLOAT__ == 4
+#define float32_t float
+#elif __SIZEOF_DOUBLE__ == 4
+#define float32_t double
+#elif __SIZEOF_LONG_DOUBLE__ == 4
+#define float32_t long double
+#endif
+
+#if __SIZEOF_FLOAT__ == 8
+#define float64_t float
+#elif __SIZEOF_DOUBLE__ == 8
+#define float64_t double
+#elif __SIZEOF_LONG_DOUBLE__ == 8
+#define float64_t long double
+#endif
+
+#if __SIZEOF_FLOAT__ == 12
+#define float96_t float
+#elif __SIZEOF_DOUBLE__ == 12
+#define float96_t double
+#elif __SIZEOF_LONG_DOUBLE__ == 12
+#define float96_t long double
+#endif
+
+#if __SIZEOF_FLOAT__ == 16
+#define float128_t float
+#elif __SIZEOF_DOUBLE__ == 16
+#define float128_t double
+#elif __SIZEOF_LONG_DOUBLE__ == 16
+#define float128_t long double
+#endif
 
 #ifdef float32_t
Index: uspace/lib/nic/include/nic_addr_db.h
===================================================================
--- uspace/lib/nic/include/nic_addr_db.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/nic/include/nic_addr_db.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -44,4 +44,5 @@
 
 #include <adt/hash_table.h>
+#include <types/common.h>
 
 /**
Index: uspace/lib/nic/src/nic_addr_db.c
===================================================================
--- uspace/lib/nic/src/nic_addr_db.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/nic/src/nic_addr_db.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,5 +36,4 @@
  */
 #include "nic_addr_db.h"
-#include "libarch/common.h"
 #include <assert.h>
 #include <stdlib.h>
Index: uspace/lib/pcut/Makefile
===================================================================
--- uspace/lib/pcut/Makefile	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/pcut/Makefile	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -36,4 +36,4 @@
 
 test-libpcut-%: $(OUTPUT)
-	$(LD) -n $(LFLAGS) -T $(LINKER_SCRIPT) -o $@ $^ $(OUTPUT) $(BASE_LIBS)
+	$(LD) -n $(LFLAGS) -T $(LINKER_SCRIPT) -o $@ $(STARTUP) $^ $(OUTPUT) $(BASE_LIBS)
 
Index: uspace/lib/pcut/update-from-master.sh
===================================================================
--- uspace/lib/pcut/update-from-master.sh	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/pcut/update-from-master.sh	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -80,5 +80,5 @@
 
 test-libpcut-%: $(OUTPUT)
-	$(LD) -n $(LFLAGS) -T $(LINKER_SCRIPT) -o $@ $^ $(OUTPUT) $(BASE_LIBS)
+	$(LD) -n $(LFLAGS) -T $(LINKER_SCRIPT) -o $@ $(STARTUP) $^ $(OUTPUT) $(BASE_LIBS)
 
 EOF_MAKEFILE_TAIL
Index: uspace/lib/posix/include/posix/limits.h
===================================================================
--- uspace/lib/posix/include/posix/limits.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/limits.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -42,8 +42,4 @@
 #define PATH_MAX 256
 
-/* it's probably a safe assumption */
-#undef CHAR_BIT
-#define CHAR_BIT 8
-
 #endif /* POSIX_LIMITS_H_ */
 
Index: uspace/lib/posix/include/posix/locale.h
===================================================================
--- uspace/lib/posix/include/posix/locale.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/locale.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -40,7 +40,5 @@
 #endif
 
-#ifndef NULL
-	#define NULL ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 #ifndef __locale_t_defined
Index: uspace/lib/posix/include/posix/stddef.h
===================================================================
--- uspace/lib/posix/include/posix/stddef.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/stddef.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -42,7 +42,5 @@
 #include "sys/types.h"
 
-#ifndef NULL
-	#define NULL  ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 #define offsetof(type,member) ((size_t) &(((type *) 0)->member))
Index: uspace/lib/posix/include/posix/stdint.h
===================================================================
--- uspace/lib/posix/include/posix/stdint.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/stdint.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -42,44 +42,4 @@
 #include "libc/stdint.h"
 
-#undef INT8_MAX
-#undef INT8_MIN
-#define INT8_MAX  127
-#define INT8_MIN  (-128)
-
-#undef UINT8_MAX
-#undef UINT8_MIN
-#define UINT8_MAX  255
-#define UINT8_MIN  0
-
-#undef INT16_MAX
-#undef INT16_MIN
-#define INT16_MAX  32767
-#define INT16_MIN  (-32768)
-
-#undef UINT16_MAX
-#undef UINT16_MIN
-#define UINT16_MAX  65535
-#define UINT16_MIN  0
-
-#undef INT32_MAX
-#undef INT32_MIN
-#define INT32_MAX  2147483647
-#define INT32_MIN  (-INT32_MAX - 1)
-
-#undef UINT32_MAX
-#undef UINT32_MIN
-#define UINT32_MAX  4294967295U
-#define UINT32_MIN  0U
-
-#undef INT64_MAX
-#undef INT64_MIN
-#define INT64_MAX  9223372036854775807LL
-#define INT64_MIN  (-INT64_MAX - 1LL)
-
-#undef UINT64_MAX
-#undef  UINT64_MIN
-#define UINT64_MAX  18446744073709551615ULL
-#define UINT64_MIN  0ULL
-
 #undef OFF64_MAX
 #undef OFF64_MIN
@@ -92,41 +52,4 @@
 #define AOFF64_MIN  UINT64_MIN
 
-#undef INTMAX_MIN
-#undef INTMAX_MAX
-#define INTMAX_MIN INT64_MIN
-#define INTMAX_MAX INT64_MAX
-
-#undef UINTMAX_MIN
-#undef UINTMAX_MAX
-#define UINTMAX_MIN UINT64_MIN
-#define UINTMAX_MAX UINT64_MAX
-
-/*
- * Fast* and least* integer types.
- *
- * The definitions below are correct as long as uint8/16/32/64_t are defined.
- * Considering the entire rest of the system would break down if they were not,
- * these definitions are just fine.
- */
-typedef uint8_t uint_least8_t;
-typedef uint16_t uint_least16_t;
-typedef uint32_t uint_least32_t;
-typedef uint64_t uint_least64_t;
-
-typedef int8_t int_least8_t;
-typedef int16_t int_least16_t;
-typedef int32_t int_least32_t;
-typedef int64_t int_least64_t;
-
-typedef uint8_t uint_fast8_t;
-typedef uint16_t uint_fast16_t;
-typedef uint32_t uint_fast32_t;
-typedef uint64_t uint_fast64_t;
-
-typedef int8_t int_fast8_t;
-typedef int16_t int_fast16_t;
-typedef int32_t int_fast32_t;
-typedef int64_t int_fast64_t;
-
 #endif /* POSIX_STDINT_H_ */
 
Index: uspace/lib/posix/include/posix/stdlib.h
===================================================================
--- uspace/lib/posix/include/posix/stdlib.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/stdlib.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -43,7 +43,5 @@
 #include "sys/types.h"
 
-#ifndef NULL
-	#define NULL  ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 #define RAND_MAX  714025
Index: uspace/lib/posix/include/posix/string.h
===================================================================
--- uspace/lib/posix/include/posix/string.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/string.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -51,7 +51,5 @@
  */
 
-#ifndef NULL
-	#define NULL  ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 /*
Index: uspace/lib/posix/include/posix/strings.h
===================================================================
--- uspace/lib/posix/include/posix/strings.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/strings.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -42,5 +42,5 @@
 
 
-#include <types/common.h>
+#include "libc/types/common.h"
 
 /* Search Functions */
Index: uspace/lib/posix/include/posix/time.h
===================================================================
--- uspace/lib/posix/include/posix/time.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/posix/include/posix/time.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -43,7 +43,5 @@
 #include "sys/types.h"
 
-#ifndef NULL
-	#define NULL  ((void *) 0)
-#endif
+#include <_bits/NULL.h>
 
 #ifndef CLOCKS_PER_SEC
Index: uspace/lib/trackmod/xm.c
===================================================================
--- uspace/lib/trackmod/xm.c	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/trackmod/xm.c	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -38,4 +38,5 @@
 #include <stdlib.h>
 #include <mem.h>
+#include <types/common.h>
 
 #include "byteorder.h"
Index: uspace/lib/usb/Makefile
===================================================================
--- uspace/lib/usb/Makefile	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/usb/Makefile	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -31,5 +31,4 @@
 EXTRA_CFLAGS += \
 	-I$(LIBDRV_PREFIX)/include \
-	-I$(LIBUSBDEV_PREFIX)/include \
 	-Iinclude
 
Index: uspace/lib/usb/include/usb/request.h
===================================================================
--- uspace/lib/usb/include/usb/request.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/usb/include/usb/request.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -37,4 +37,5 @@
 
 #include <stdint.h>
+#include <assert.h>
 
 /** Standard device request. */
@@ -107,5 +108,5 @@
 } __attribute__ ((packed)) usb_device_request_setup_packet_t;
 
-int assert[(sizeof(usb_device_request_setup_packet_t) == 8) ? 1: -1];
+static_assert(sizeof(usb_device_request_setup_packet_t) == 8);
 
 int usb_request_needs_toggle_reset(
Index: uspace/lib/usb/include/usb/usb.h
===================================================================
--- uspace/lib/usb/include/usb/usb.h	(revision 2b11c3c0cf74426080bd899202376055d7cb591d)
+++ uspace/lib/usb/include/usb/usb.h	(revision f834dd816464592376050320f24119ef2aabf8e8)
@@ -39,4 +39,5 @@
 #include <stdint.h>
 #include <types/common.h>
+#include <usb_iface.h>
 
 /** Convert 16bit value from native (host) endianness to USB endianness. */
@@ -52,36 +53,8 @@
 #define uint32_usb2host(n) uint32_t_le2host((n))
 
-
-/** USB transfer type. */
-typedef enum {
-	USB_TRANSFER_CONTROL = 0,
-	USB_TRANSFER_ISOCHRONOUS = 1,
-	USB_TRANSFER_BULK = 2,
-	USB_TRANSFER_INTERRUPT = 3
-} usb_transfer_type_t;
-
 const char * usb_str_transfer_type(usb_transfer_type_t t);
 const char * usb_str_transfer_type_short(usb_transfer_type_t t);
 
-/** USB data transfer direction. */
-typedef enum {
-	USB_DIRECTION_IN,
-	USB_DIRECTION_OUT,
-	USB_DIRECTION_BOTH
-} usb_direction_t;
-
 const char *usb_str_direction(usb_direction_t);
-
-/** USB speeds. */
-typedef enum {
-	/** USB 1.1 low speed (1.5Mbits/s). */
-	USB_SPEED_LOW,
-	/** USB 1.1 full speed (12Mbits/s). */
-	USB_SPEED_FULL,
-	/** USB 2.0 high speed (480Mbits/s). */
-	USB_SPEED_HIGH,
-	/** Psuedo-speed serving as a boundary. */
-	USB_SPEED_MAX
-} usb_speed_t;
 
 static inline bool usb_speed_is_11(const usb_speed_t s)
@@ -108,9 +81,4 @@
 } usb_request_recipient_t;
 
-/** USB address type.
- * Negative values could be used to indicate error.
- */
-typedef int16_t usb_address_t;
-
 /** Default USB address. */
 #define USB_ADDRESS_DEFAULT 0
@@ -132,9 +100,4 @@
 }
 
-/** USB endpoint number type.
- * Negative values could be used to indicate error.
- */
-typedef int16_t usb_endpoint_t;
-
 /** Default control endpoint */
 #define USB_ENDPOINT_DEFAULT_CONTROL 0
@@ -155,16 +118,4 @@
 	    (ep < USB11_ENDPOINT_MAX);
 }
-
-
-/** USB complete address type. 
- * Pair address + endpoint is identification of transaction recipient.
- */
-typedef union {
-	struct {
-		usb_address_t address;
-		usb_endpoint_t endpoint;
-	} __attribute__((packed));
-	uint32_t packed;
-} usb_target_t;
 
 /** Check USB target for allowed values (address and endpoint).
